class Tb_basecode_class {
    constructor(container) {
        this.ajaxUrl = "./basecode.ajax.php";
        this.tbList = "";
        this.Code = {};

        this.container = document.querySelector(container);
        this.table = this.container.querySelector(".hy-table");
        this.addBtn = this.container.querySelector(".add-btn");
        this.removeBtn = this.container.querySelector(".remove-btn");
    }

    /*
     * @Overview 데이터 세팅 함수
     * @Parameter 없음
     */
    getMainList(code) {
        this.code = code;
        let talert = window.setTimeout(() => { this.tbList.alert("Loading ..."); }, 1000);

        ajax_json({
            url: this.ajaxUrl,
            data: {
                mode: "getCodeList",
                Bran_Uid: code.Bran_Uid,
                Group_Uid: code.Bran_Uid !== code.Group_Uid ? code.Group_Uid : "",
            },
            success: (data) => {
                if (data.code) {
                    let gnum = data.data.filter(v => v.Bran_Uid !== v.Code_Uid && v.Group_Uid === v.Code_Uid).length; //gnum 이 0보다 크면 3단 코드
                    if (gnum > 0) {
                        if (code.Bran_Uid === code.Group_Uid) {
                            this.Code = { Bran_Uid: code.Bran_Uid, Group_Uid: '', Code_Exp: code.Code_Exp, };
                        } else {
                            this.Code = { Bran_Uid: code.Bran_Uid, Group_Uid: code.Group_Uid, Code_Exp: code.Code_Exp, };
                        }
                    } else {
                        this.Code = { Bran_Uid: code.Bran_Uid, Group_Uid: code.Bran_Uid, Code_Exp: code.Code_Exp, };
                    }

                    if (code.Bran_Uid === code.Group_Uid && data.data.filter(v => v.Bran_Uid !== v.Group_Uid).length) {
                        this.tbList.setData(data.data.filter(v => v.Bran_Uid !== v.Code_Uid && v.Group_Uid === v.Code_Uid));
                    } else {
                        this.tbList.setData(data.data.filter(v => v.Bran_Uid !== v.Code_Uid && v.Group_Uid !== v.Code_Uid));
                    }
                    //2단 사용시 위 제외하고 아래만 존재하면 된다.
                    //_this.tbList.setData(data.data.filter(v=>v.Bran_Uid !== v.Code_Uid && v.Group_Uid !== v.Code_Uid));
                    // document.querySelector("#txtBaseTitle").innerHTML=`( ${this.Code['Code_Exp']} )`;
                    // document.querySelector("#btnAddBcode").removeAttribute("disabled");
                    // document.querySelector("#btnPutBcode").removeAttribute("disabled");
                    // this.tbList.getRows().forEach(row=>{
                    //   row.getCell("Code_Uid").getElement().addEventListener("click",(e)=>{
                    //     this.rowClick(e,row);
                    //   })
                    // });
                } else {
                    kuls_alert(data.mesg);

                }
            },
            error: (req, status, err) => {
                kuls_alert(err.message);
            },
            complete: () => {
                window.clearTimeout(talert);
                this.tbList.clearAlert();
            },
        });
        return true;
    }
    /*
     * @Overview 데이터 필터 함수
     * @Parameter 없음
     * @function 필터링 없음.
     */
    setFilter() {
    }

    /*
     * @Overview 테이블 행 추가 함수
     * @Parameter 없음
     * @function 기본키, _STATUS_:I 값을 넣은 행 추가
     */
    addRow() {
        if (this.code) {
            this.tbList.addRow({ _STATUS_: "I", Bran_Active: "Y", Bran_Uid: this.code.Bran_Uid, Group_Uid: this.code.Group_Uid, }, true);
        } else {
            kuls_alert("기초코드를 선택해주세요");
        }
    }

    /*
     * @Overview 테이블 행 삭제 함수
     * @Parameter 없음
     * @function 선택된 모든 행 STATUS D
     */
    removeRow() {
        const selectedRows = this.tbList.getRows().filter(row => {
            return row.getData().check === "Y";
        });

        if (selectedRows.length > 0) {

            // 선택된 각 행 삭제
            selectedRows.forEach((row) => {
                // STAUS D로 바꾸기
                row.getData()._STATUS_ = row.getData()._STATUS_ == "I" ? null : "D";

                const rowElement = row.getElement();
                rowElement.classList.add("remove-row");

            });
        } else {
            kuls_alert("삭제할 행을 선택해주세요.");
        }
    }

    /*
     * @Overview 테이블 행 선택 함수
     * @Parameter 없음
     * @function 선택된 모든 행 색 변경
     */
    rowClick(e, tgt) {
        if (tgt.isSelected()) {
            tgt.deselect();
            this.clearRemove(tgt);
        } else {
            tgt.select();
        }
    }

    /*
     * @Overview 삭제 취소 함수
     * @Parameter 삭제 행
     * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
     */
    clearRemove(tgt) {
        if (tgt._row.data._STATUS_ == "D") {
            // console.log();
            tgt._row.data._STATUS_ = "";
            tgt._row.getElement().classList.remove("remove-row");
            // const selectedRows = this.tbList.getSelectedRows(); // 선택된 모든 행 가져오기
        }
    }

    /*
     * @Overview cell 클릭 함수
     * @Parameter 클릭한 cell
     * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
     */
    cellClick(e, tgt) {

        switch (tgt.getField()) {
            case "Bran_Active":
                tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
                break;
            case "check":
                tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
                this.clearRemove(tgt.getRow());
                break;
        }
    }

    /*
     * @Overview 테이블 셀 수정 함수
     * @Parameter 셀
     * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
     */
    cellEdited(cell) {
        cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
    }

    /*
     * @Overview 추가, 수정 및 삭제 데이터 저장
     * @Parameter 없음
     * @Function 기본키 중복 확인
     * @Function _STATUS_ U, I, D인 데이터베이스 가져와서 처리.
     */
    putData() {
    }



    /*
     * @Overview 추가, 수정 및 삭제 데이터 저장
     * @Parameter 없음
     * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
     */
    putData() {

        // 저장 시 상태 변화 없는 row 요청 X
        if (this.tbList.getData().filter(row => row._STATUS_).length == 0) {
            this.getMainList(this.code);
            return false;
        }

        const blankObj = [];
        const reqData = [];

        this.tbList.getRows().forEach(row => {
            if (row.getData()['_STATUS_']) {
                if (Object.keys(row._row.data).filter(key => key !== '_STATUS_' && key !== 'Bran_Active' && key !== 'Bran_Uid' && key !== 'Group_Uid').every(key => {

                    const value = row._row.data[key];
                    return (value === undefined || value === '');
                })) {
                    blankObj.push(row);
                } else {
                    reqData.push(row.getData());
                }
            }
        });


        const postdata = reqData.length == 0 ? false : {
            'mode': 'putCode',
            'reqdata': JSON.stringify(reqData),
        };

        if (!postdata) {
            this.getMainList(this.code);
            return false;
        };

        console.log(reqData);

        if (blankObj.length !== 0) {
            kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?", "", () => {
                ajax_json({
                    url: this.ajaxUrl,
                    data: postdata,
                    success: (data) => {
                        if (data.code) {
                            kuls_success("저장되었습니다.");
                            this.getMainList(this.code);
                        } else {
                            kuls_alert(data.mesg);
                        }
                    },
                    error: function(request, status, error) {
                        kuls_alert(error.message);
                    },
                    complete: function() {
                    }
                });

            }, () => {
                blankObj.forEach(row => {
                    row.getElement().classList.add("blank-row");
                });
            });
        } else {
            ajax_json({
                url: this.ajaxUrl,
                data: postdata,
                success: (data) => {
                    if (data.code) {
                        kuls_success("저장되었습니다.");
                        this.getMainList(this.code);
                    } else {
                        kuls_alert(data.mesg);
                    }
                },
                error: function(request, status, error) {
                    kuls_alert(error.message);
                },
                complete: function() {
                }
            });


        }

    }

    /*
     * @Overview 최초 실행 함수
     * @Parameter 없음
     */
    init() {
        // field 정의
        const fields = [
            {
                field: "check", title: "삭제", width: 50, headerSort: false,
                formatter: tb_common_funtions.formatterCheckboxIcon,
                formatterParams: { checkval: "Y" },
            },
            { field: "rownum", title: "NO", width: 50, formatter: "rownum", },
            {
                field: "Code_Uid", title: "Code", width: 100,
                editor: tb_custom_editor.pkCode,
                editorParams: { 'type': 'upper' },
                formatter: tb_custom_formatter.pkCode,
                formatterParams: { tableClass: this },
            },
            { field: "Code_Val", title: "Value", width: 150, cssClass: 'editable-cell', editor: tb_custom_editor.upper, },
            { field: "Code_Exp", title: "설명", width: 150, cssClass: 'editable-cell', editor: "input" },
            { field: "Bran_Active", title: "사용", width: 50, cssClass: 'tabulator-editable', formatter: tb_common_funtions.formatterToggleboxGreenIcon, formatterParams: { checkval: 'Y' }, },
        ];
        const commonFieldData = {
            headerSort: false,
            vertAlign: "middle",
            hozAlign: "center",
            resizable: "header",
            headerHozAlign: "center",
            headerSortTristate: true, //데이터 정렬 => 정/역/초기화
        };

        /*
         * @Overview tabulator 객체 생성
         * @Parameter 생성 위치(html class값)
         */
        this.tbList = new Tabulator(this.table, {
            layout: "fitColumns",
            data: [],
            columns: fields,
            columnDefaults: commonFieldData,
            movableRows: true,
            validationMode: "highlight"
        });

        /*
         * @Overview 유효성 검사메세지 띄우기
         * @Parameter cell, 입력값, validators
         */
        this.tbList.on("validationFailed", (cell, value, validators) => {
            cell.setValue("");
            let errMsg = "";
            switch (validators[0].type) {
                case "alphanumeric":
                    errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
                    break;
                case "numeric":
                    errMsg = " 필드는 숫자만 입력할 수 있습니다.";
                    break;
                default:
                    errMsg = " 필드는 " + validators[0].parameters;
                    break;

            };

            kuls_warning(cell.getColumn().getDefinition().title + errMsg);
        });

        /*
         * @Overview cell 클릭시 체크 또는 팝업
         * @Parameter 이벤트, 셀
         */
        this.tbList.on("cellClick", (e, tgt) => {
            this.cellClick && this.cellClick(e, tgt);
        });

        /*
         * @Overview cell 수정 함수
         * @Parameter cell
         * @Function status u로 바꿀것
         */
        this.tbList.on("cellEdited", (cell) => {
            this.cellEdited && this.cellEdited(cell);
        });

        // 추가
        ["click", "keypress"].forEach((evt) => {
            this.addBtn.addEventListener(evt, () => {
                this.addRow && this.addRow();
            });
        });
        // 삭제
        ["click", "keypress"].forEach((evt) => {
            this.removeBtn.addEventListener(evt, () => {
                // 삭제 함수
                this.removeRow && this.removeRow();
            });
        });
        // 조회
        ["click", "keypress"].forEach((evt) => {
            const filterBtn = document.querySelector("#filter_btn");
            filterBtn.addEventListener(evt, () => {
                // setFilter 또는 setData
                this.setFilter && this.setFilter();
            });
        });
        // 저장
        ["click", "keypress"].forEach((evt) => {
            const putBtn = document.querySelector("#put_btn");
            putBtn.addEventListener(evt, () => {
                this.putData && this.putData();
            });
        });
    }
}
